#!/usr/bin/Rscript
library(ggplot2)
boil <- function(x) { 0.002678 * x**2 }

linearfit <- function(fun, x1, x2) {
    y1 <- fun(x1)
    y2 <- fun(x2)

    k <- (y2 - y1) / (x2 - x1)
    d <- ((y1 * x2) - (y2 * x1)) / (x2 - x1)

    print(sprintf("%f * x + %f", k, d))
    return(function(x) k * x + d)
}

g <- ggplot(data.frame(x=35,55)) +
    stat_function(fun=boil, alpha=0.5) +
    stat_function(fun=linearfit(boil, 40, 50), alpha=0.5, color='red', linetype=2) +
    xlim(40,50) +
    geom_point(x=41, y=boil(41), aes(shape="S")) +
    geom_point(x=42.3, y=boil(42.3), aes(shape="M")) +
    geom_point(x=44.6, y=boil(44.6), aes(shape="L")) +
    geom_point(x=47.35, y=boil(47.35), aes(shape="XL")) +
    xlab("d [mm]") + ylab("t [min]") +
    scale_y_continuous(breaks=c(boil(41), boil(42.3), boil(44.6), boil(47.35), 300, 350, 400)) +
    theme_classic()


png('plot.png')
plot(g)
dev.off()





